#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Symbol.ico
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <GDIP.au3>
#include <Misc.au3>

$title = "Souris Editor"
$width = 500
$height = 500
$color = 4278190080
$size = 5
$state = 1
$penwidth = 1
Global $time = 0
Global $pw = 0, $description = ""
Dim $start[2] = [0, 0]
Opt("GUIOnEventMode", 1)
$gui = GUICreate($title, $width, $height)
GUISetOnEvent(-3, "close")
_GDIPlus_Startup()
$graphics = _GDIPlus_GraphicsCreateFromHWND($gui)
$bitmap = _GDIPlus_BitmapCreateFromGraphics($width, $height, $graphics)
$buffer = _GDIPlus_ImageGetGraphicsContext($bitmap)
$background = _GDIPlus_BitmapCreateFromGraphics($width, $height, $graphics)
$bgbuffer = _GDIPlus_ImageGetGraphicsContext($background)
_GDIPlus_GraphicsClear($bgbuffer, 4278255615)
$brush = _GDIPlus_BrushCreateSolid()
$pen = _GDIPlus_PenCreate()
GUISetState()
GUIRegisterMsg(0x000F, "draw")
GUIRegisterMsg(0x020A, "mouse")
$dll = DllOpen("user32.dll")

While True
	If WinActive($gui) Then
		$info = GUIGetCursorInfo($gui)
		If _IsPressed("4D", $dll) Then
			$size += 1
			TrayTip($title, "Player size:" & $size, 100)
			Sleep(100)
		EndIf
		If _IsPressed("4E", $dll) And $size <> 1 Then
			$size -= 1
			TrayTip($title, "Player size:" & $size, 100)
			Sleep(100)
		EndIf
		If _IsPressed(58, $dll) And $time <> 255 Then
			$time += 1
			TrayTip($title, "Player time:" & $time, 100)
			Sleep(100)
		EndIf
		If _IsPressed(59, $dll) And $time <> 0 Then
			$time -= 1
			TrayTip($title, "Player time:" & $time, 100)
			Sleep(100)
		EndIf
		If _IsPressed(50, $dll) Then
			$pw = InputBox($title, "Map password:" & @CRLF & "Only numbers (max.4095)")
			TrayTip($title, "Map password: " & Dec(Hex($pw, 3)), 100)
		EndIf
		If _IsPressed(51, $dll) Then $state = 1
		If _IsPressed(57, $dll) Then $state = 2
		If _IsPressed(45, $dll) Then $state = 3
		If _IsPressed(52, $dll) Then $state = 4
		If _IsPressed(54, $dll) Then $state = 5
		If _IsPressed(31, $dll) Then $color = 4278190080
		If _IsPressed(32, $dll) Then $color = 4278255615
		If _IsPressed(33, $dll) Then $color = 4294901760
		If _IsPressed(75, $dll) Then
			$path = FileOpenDialog("Open map", "", "All (*.*)")
			If Not @error Then
				_GDIPlus_GraphicsClear($bgbuffer, 4294967295)
				loadmap($path)
			EndIf
		EndIf
		If _IsPressed(74, $dll) Then
			$msg = MsgBox(52, $title, "Do you really want to create a new map")
			If $msg = 6 Then
				$start[0] = 0
				$start[1] = 0
				$size = 5
				$time = 0
				$pw = 0
				$description = ""
				_GDIPlus_GraphicsClear($bgbuffer, 4278255615)
			EndIf
		EndIf
		If _IsPressed(76, $dll) Then
			$path = FileSaveDialog("Save map", "", "All (*.*)")
			If Not @error Then savemap($path)
		EndIf
		If _IsPressed(4, $dll) Then
			$start[0] = $info[0]
			$start[1] = $info[1]
			TrayTip($title, "Startposition:" & @CRLF & $start[0] & @CRLF & $start[1], 100)
		EndIf
		If _IsPressed("4C", $dll) Then
			$description = InputBox($title, "Map description:")
			If StringLen($description) > 4095 Then $description = ""
			TrayTip($title, "Map description:" & @CRLF & StringReplace(BinaryToString(StringToBinary($description)), "\n", @CRLF), 100)
		EndIf
		If _IsPressed(2, $dll) Then _GDIPlus_BitmapSetPixel($background, $info[0], $info[1], $color)
		If _IsPressed(1, $dll) Then
			_GDIPlus_PenSetColor($pen, $color)
			_GDIPlus_BrushSetSolidColor($brush, $color)
			While _IsPressed(1, $dll)
				clear()
				$info2 = GUIGetCursorInfo($gui)
				$dw = $info2[1] - $info[1]
				If _IsPressed(11, $dll) Then $dw = $info2[0] - $info[0]
				Switch $state
					Case 1
						_GDIPlus_GraphicsFillRect($buffer, $info[0], $info[1], $info2[0] - $info[0], $dw, $brush)
					Case 2
						_GDIPlus_GraphicsDrawLine($buffer, $info[0], $info[1], $info2[0], $info2[1], $pen)
					Case 3
						_GDIPlus_GraphicsDrawRect($buffer, $info[0], $info[1], $info2[0] - $info[0], $dw, $pen)
					Case 4
						_GDIPlus_GraphicsFillEllipse($buffer, $info[0], $info[1], $info2[0] - $info[0], $dw, $brush)
					Case 5
						_GDIPlus_GraphicsDrawEllipse($buffer, $info[0], $info[1], $info2[0] - $info[0], $dw, $pen)
				EndSwitch
				draw()
			WEnd
			Switch $state
				Case 1
					_GDIPlus_GraphicsFillRect($bgbuffer, $info[0], $info[1], $info2[0] - $info[0], $dw, $brush)
				Case 2
					_GDIPlus_GraphicsDrawLine($bgbuffer, $info[0], $info[1], $info2[0], $info2[1], $pen)
				Case 3
					_GDIPlus_GraphicsDrawRect($bgbuffer, $info[0], $info[1], $info2[0] - $info[0], $dw, $pen)
				Case 4
					_GDIPlus_GraphicsFillEllipse($bgbuffer, $info[0], $info[1], $info2[0] - $info[0], $dw, $brush)
				Case 5
					_GDIPlus_GraphicsDrawEllipse($bgbuffer, $info[0], $info[1], $info2[0] - $info[0], $dw, $pen)
			EndSwitch
		EndIf
	EndIf
	clear()
	draw()
WEnd

Func mouse($hwnd, $wParam, $lParam)
	If $lParam < 4287102976 Then
		$penwidth += 1
	ElseIf $penwidth <> 1 Then
		$penwidth -= 1
	EndIf
	_GDIPlus_PenSetWidth($pen, $penwidth)
	TrayTip($title, "Pen width:" & $penwidth, 100)
EndFunc   ;==>mouse

Func clear()
	_GDIPlus_GraphicsClear($buffer, 4294967295)
	_GDIPlus_GraphicsDrawImage($buffer, $background, 0, 0)
EndFunc   ;==>clear

Func draw()
	_GDIPlus_GraphicsDrawImage($graphics, $bitmap, 0, 0)
EndFunc   ;==>draw

Func close()
	DllClose($dll)
	GUIDelete()
	_GDIPlus_PenDispose($pen)
	_GDIPlus_BrushDispose($brush)
	_GDIPlus_GraphicsDispose($bgbuffer)
	_GDIPlus_BitmapDispose($background)
	_GDIPlus_GraphicsDispose($buffer)
	_GDIPlus_BitmapDispose($bitmap)
	_GDIPlus_GraphicsDispose($graphics)
	_GDIPlus_Shutdown()
	Exit
EndFunc   ;==>close

Func savemap($filename)
	Local $color, $x = 0, $y = 0, $data = "", $pixel, $len = $width * $height - 1
	$data &= Hex($start[0], 3)
	$data &= Hex($start[1], 3)
	$data &= Hex($size, 1)
	$data &= Hex($time, 2)
	$data &= Hex($pw, 3)
	$data &= Hex(StringLen(StringToBinary($description)), 3)
	$data &= StringToBinary($description)
	_GDIPlus_GraphicsClear($buffer, 0xFFDDDDDD)
	_GDIPlus_GraphicsDrawString($buffer, "Please wait", Random(0, $width - 200), Random(0, $height - 200), "Arial", 20)
	_GDIPlus_GraphicsDrawImage($graphics, $bitmap, 0, 0)
	DllCall(@ScriptDir & "\Souris.dll", "none", "SaveMap", "int", $background, "int", $len, "int", $width, "str", $filename, "str", $data)
EndFunc   ;==>savemap

Func loadmap($filename)
	Local $file = FileOpen($filename)
	Local $read = FileRead($file)
	FileClose($file)
	Local $pw = Dec(StringMid($read, 10, 3))
	If $pw <> 0 Then
		Do
			$input = InputBox($title, "Map password:")
			If @error Then Return
		Until $input = $pw
	EndIf
	_GDIPlus_GraphicsClear($buffer, 0xFFDDDDDD)
	_GDIPlus_GraphicsDrawString($buffer, "Please wait", Random(0, $width - 200), Random(0, $height - 200), "Arial", 20)
	_GDIPlus_GraphicsDrawImage($graphics, $bitmap, 0, 0)
	$time = Dec(StringMid($read, 8, 2))
	Local $color, $x = 0, $y = 0, $len = StringLen($read)
	Local $dlen = Dec(StringMid($read, 13, 3))
	$description = BinaryToString(StringMid($read, 16, $dlen))
	DllCall(@ScriptDir & "\Souris.dll", "none", "LoadMap", "int", $background, "int", 16 + $dlen, "int", $len, "int", $width, "str", $filename)
	$start[0] = Dec(StringMid($read, 1, 3))
	$start[1] = Dec(StringMid($read, 4, 3))
	$size = Dec(StringMid($read, 7, 1))
EndFunc   ;==>loadmap
