#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Symbol.ico
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <GDIP.au3>
#include <Misc.au3>

$title = "Souris"
$width = 500
$height = 500
$play = False
$timer = 0
$time = 0
Dim $start[2] = [0, 0]
$size = 5
Global $next = ""
Dim $logs[20000][2]
Global $logend = 0, $logpos = 0, $logtimer, $loglen = UBound($logs) - 1
Global $description
Global $info[3] = [0, 0, 1]
Opt("GUIOnEventMode", 1)
$gui = GUICreate($title, $width, $height)
GUISetOnEvent(-3, "close")
_GDIPlus_Startup()
$graphics = _GDIPlus_GraphicsCreateFromHWND($gui)
$bitmap = _GDIPlus_BitmapCreateFromGraphics($width, $height, $graphics)
$buffer = _GDIPlus_ImageGetGraphicsContext($bitmap)
$background = _GDIPlus_BitmapCreateFromGraphics($width, $height, $graphics)
$brush = _GDIPlus_BrushCreateSolid(4278190335)
$brush2 = _GDIPlus_BrushCreateSolid(4294967295)
$brush3 = _GDIPlus_BrushCreateSolid(1426063615)
GUISetState()
GUIRegisterMsg(0x000F, "draw")
$dll = DllOpen("user32.dll")
draw()
open()

While True
	draw()
WEnd

Func open()
	$path = FileOpenDialog("Load map", "", "All (*.*)")
	If Not @error Then loadmap($path)
EndFunc   ;==>open

Func draw()
	_GDIPlus_GraphicsClear($buffer)
	_GDIPlus_GraphicsDrawImage($buffer, $background, 0, 0)
	If WinActive($gui) Then
		If _IsPressed("4C", $dll) Then open()
		If $play Then
			If $time <> 0 Then
				If TimerDiff($timer) >= $time * 1000 Then
					restart()
				EndIf
				_GDIPlus_GraphicsFillRect($buffer, $width - 18, 0, 18, 18, $brush2)
				_GDIPlus_GraphicsDrawString($buffer, $time - Int(TimerDiff($timer) / 1000), $width, 0, "Arial", 10, 1)
			EndIf
			If _IsPressed(57, $dll) Then
				$info[2] = 3
			Else
				$info[2] = 1
			EndIf
			If _IsPressed(27, $dll) Then $info[0] += $info[2]
			If _IsPressed(25, $dll) Then $info[0] -= $info[2]
			If _IsPressed(26, $dll) Then $info[1] -= $info[2]
			If _IsPressed(28, $dll) Then $info[1] += $info[2]
			If $logpos < $loglen Then
				If $logpos <= $logend Then
					_GDIPlus_GraphicsFillRect($buffer, $logs[$logpos][0] - $size, $logs[$logpos][1] - $size, $size + $size + 1, $size + $size + 1, $brush3)
				EndIf
				If TimerDiff($logtimer) >= 30 Then
					$logs[$logpos][0] = $info[0]
					$logs[$logpos][1] = $info[1]
					$logpos += 1
					$logtimer = TimerInit()
				EndIf
			EndIf
			For $x = $info[0] - $size To $info[0] + $size
				For $y = $info[1] - $size To $info[1] + $size
					$pixel = _GDIPlus_BitmapGetPixel($background, $x, $y)
					If $pixel = 4278190080 Then
						restart()
						ExitLoop 2
					ElseIf $pixel = 4294901760 Then
						$text = "You won" & @CRLF & "Next Level [SPACE]" & @CRLF & "Repeat level [TAB]" & @CRLF & @CRLF & StringReplace($description, "\n", @CRLF)
						TrayTip($title, $text, 100)
						Do
							_GDIPlus_GraphicsClear($buffer, 0xFFDDDDDD)
							_GDIPlus_GraphicsDrawString($buffer, $text, 0, 0, "Arial", 20)
							_GDIPlus_GraphicsDrawImage($graphics, $bitmap, 0, 0)
							Sleep(50)
						Until _IsPressed(20, $dll) Or _IsPressed(9, $dll)
						If _IsPressed(20, $dll) Then
							If $next = "" Then
								open()
							Else
								loadmap($next, False)
							EndIf
						EndIf
						If _IsPressed(9, $dll) Then restart()
						ExitLoop 2
					EndIf
				Next
			Next
			_GDIPlus_GraphicsFillRect($buffer, $info[0] - $size, $info[1] - $size, $size + $size + 1, $size + $size + 1, $brush)
		EndIf
	EndIf
	_GDIPlus_GraphicsDrawImage($graphics, $bitmap, 0, 0)
EndFunc   ;==>draw

Func restart()
	$logend = $logpos - 1
	$info[0] = $start[0]
	$info[1] = $start[1]
	If $time <> 0 Then $timer = TimerInit()
	$logpos = 0
	$logtimer = TimerInit()
EndFunc   ;==>restart

Func close()
	DllClose($dll)
	GUIDelete()
	_GDIPlus_BrushDispose($brush3)
	_GDIPlus_BrushDispose($brush2)
	_GDIPlus_BrushDispose($brush)
	_GDIPlus_BitmapDispose($background)
	_GDIPlus_GraphicsDispose($buffer)
	_GDIPlus_BitmapDispose($bitmap)
	_GDIPlus_GraphicsDispose($graphics)
	_GDIPlus_Shutdown()
	Exit
EndFunc   ;==>close

Func loadmap($filename, $query = True)
	Local $file = FileOpen($filename)
	Local $read = FileRead($file)
	FileClose($file)
	If $query Then
		Local $pw = Dec(StringMid($read, 10, 3))
		If $pw <> 0 Then
			Do
				$input = InputBox($title, "Map password:")
				If @error Then Return
			Until $input = $pw
		EndIf
	EndIf
	_GDIPlus_GraphicsClear($buffer, 0xFFDDDDDD)
	_GDIPlus_GraphicsDrawString($buffer, "Please wait", Random(0, $width - 200), Random(0, $height - 200), "Arial", 20)
	_GDIPlus_GraphicsDrawImage($graphics, $bitmap, 0, 0)
	If FileExists(StringLeft($filename, StringLen($filename) - 1) & StringRight($filename, 1) + 1) Then
		$next = StringLeft($filename, StringLen($filename) - 1) & StringRight($filename, 1) + 1
	Else
		$next = ""
	EndIf
	Local $color, $x = 0, $y = 0, $len = StringLen($read)
	$time = Dec(StringMid($read, 8, 2))
	Local $dlen = Dec(StringMid($read, 13, 3))
	$description = BinaryToString(StringMid($read, 16, $dlen))
	DllCall(@ScriptDir & "\Souris.dll", "none", "LoadMap", "int", $background, "int", 16 + $dlen, "int", $len, "int", $width, "str", $filename)
	$start[0] = Dec(StringMid($read, 1, 3))
	$start[1] = Dec(StringMid($read, 4, 3))
	$size = Dec(StringMid($read, 7, 1))
	GUISetCursor(16)
	$play = True
	restart()
	$logend = 0
EndFunc   ;==>loadmap
